import javax.swing.AbstractListModel;
import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.JPanel;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

class MyListModel extends AbstractListModel {
    protected AnnotationModel am;
    protected JPanel jp;

    public MyListModel(AnnotationModel a) { am = a; }

    protected void setUpList(JList list) {
	if(am.annotationfile != null) {
	    am.schema = am.readDocument(am.annotationfile);	    
	}
	if(am.infile != null) {
	    am.doc = am.readDocument(am.infile);
	}
	setUpJP(am.schema);
	list.setCellRenderer(new TextAreaRenderer());
	fireContentsChanged(this, 0, getSize());
    }

    public void setUpJP(Document schema) {
	jp = new JPanel();
	if(am.schema != null) {
	    NodeList nodes = am.schema.getElementsByTagName("category");
	    for(int i = 0; i < nodes.getLength(); i++) {
		JComboBox comboBox = new JComboBox(am.getAnnotationLabels(i));
		jp.add(comboBox);
	    }
	}
    }

    public int getSize() {
	if(am.doc != null) {
	    NodeList nodes = am.getUtterances();
	    return nodes.getLength();
	}
	return 0;
    }

    public Object getElementAt(int index) {
	if(am.doc != null) {
	    NodeList nodes = am.getUtterances();
	    Node n = nodes.item(index);
	    return n.getAttributes().getNamedItem("id").getNodeValue() + " " + 
		n.getAttributes().getNamedItem("speaker").getNodeValue() + " " +
		n.getFirstChild().getNodeValue();
	}
	return null;
    }
}
