import java.util.Vector;

import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/*
 * Created on Apr 18, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author sveta
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ShinAnnotationModel  extends AnnotationModel {

	
	protected NodeList getUtterances()
	{
		return doc.getElementsByTagName("utterance");
	}
	
	
	/**********************************************
	 * 
	 * @param columnNames
	 * @return adds to columnNames vector additional values
	 *  	 
	 * */
	
    protected Vector getAttColumnNames(Vector columnNames){		
 	   NamedNodeMap docNodes = getUtterances().item(0).getAttributes();

	 	   columnNames.add(new NamePair("type", 50, false));
	 	   columnNames.add(new NamePair("FirstNum", 50, false));	 	  
	 	   columnNames.add(new NamePair("First", 50, false));
	 	   columnNames.add(new NamePair("SecondNum", 50, false));
	 	   columnNames.add(new NamePair("Second", 50, false));

	 	   return columnNames;	
 	    };	

	/***********************************************
	 *  
	 * @param node
	 * @return text to display in the Utterance column
	 * this object should be turn. 
	 * get the child of turn: <text type="transcription">
	 * and get its first child
	 */
	protected Object getUtteranceText(Node node)
	{
		NodeList allChildren = node.getChildNodes();
		//get all children
		try{
		for(int i = 0; i< allChildren.getLength(); i++ )
		{
			if(allChildren.item(i).getNodeName().equals("text") )
			{
			Element element = (Element )allChildren.item(i);
			//either system or transcription
			if(element.getAttributeNode("type").getValue().equals("transcription") 
					|| element.getAttributeNode("type").getValue().equals("system")) 
				{
					return element.getFirstChild().getNodeValue();		
				}
			}
		}		
		}
		catch(Exception ex)
		{
		    return null;
		}
		return null;
	}
	
	/***********************************************
	 *  
	 * @param node
	 * @return if this is  a user turn, return asr recognition, else empty 
	 * get the child of turn: <text type="asr">
	 * and get its first child
	 */
	protected Object getASRText(Node node)
	{
		NodeList allChildren = node.getChildNodes();
		//get all children
		try{
		for(int i = 0; i< allChildren.getLength(); i++ )
		{
			if(allChildren.item(i).getNodeName().equals("text") )
			{
			Element element = (Element )allChildren.item(i);
			//either system or transcription
			if(element.getAttributeNode("type").getValue().equals("asr") )
				{
					return element.getFirstChild().getNodeValue();		
				}
			}
		}		
		}
		catch(Exception ex)
		{
		    return null;
		}
		return "";
	}	
	
	/************************************************
	 * 
	 * @param colName - column name
	 * @param thisnode - xml node to retrieve value from
	 * @return if the column name is "Utterance" return utterance text, else 
	 * 			return the the attribute value using col name
	 */	
	protected Object getValueAt(String colName, Node thisnode)
	{
		if(colName.equals("Utterance"))
		{
			return getUtteranceText(thisnode);
		}
		else
			if(colName.equals("ASR"))
			{
				return getASRText(thisnode);
			}		
		else
		if(colName.equals("number"))
		{
			return thisnode.getAttributes().getNamedItem(colName).getNodeValue();
		}		
		else
		//user utterances and some of the speaker utterances do not have this 
		//attribute set. Go one level up and get it from the turn node
		if(colName.equals("speaker"))
		{
			Node parent = thisnode.getParentNode();
			return parent.getAttributes().getNamedItem(colName).getNodeValue();
		}		
		else
		//TODO this code is annotation specific. It should not be here.
		//this is the annotation tag
		//if an utterance node has a child dialog_act with speech_act="explicit_confirm"
		// or implicit_confirm, set the value of this cell to impl or expl
		// also import 	
		if(colName.equals("SystemImported"))
		{
			NodeList children = thisnode.getChildNodes();
			for(int i = 0; i<children.getLength(); i++)			
			{
				
				if(children.item(i).getNodeName().equals("dialogue_act") )
				{
					Element element = (Element )children.item(i);				
					if (element.getAttribute("speech_act")!=null )
					{
						if(	element.getAttribute("speech_act").equals("explicit_confirm"))
						{
							return "expl";						
						}
						else
						if(	element.getAttribute("speech_act").equals("implicit_confirm"))
						{
							return "impl";						
						}
						else
						if(	element.getAttribute("task_subtask").equals("meta_start_over"))
						{
							return "startover";						
						}
						else
						if(	element.getAttribute("task_subtask").equals("meta_slu_reject"))
						{
							return "reject";						
						}		
						else
						if(	element.getAttribute("task_subtask").equals("meta_instruct"))
						{
							return "aid";						
						}								
					}	
				}
			}
			

			
			//none of the above is true, set to empty string
			return ""; 
			
			}
		else
			//last resort: match the attribute name to the col name
			return thisnode.getAttributes().getNamedItem(colName).getNodeValue();
 	}	
}
